﻿package com.viget
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Point;
	
	public class Boundary extends MovieClip
	{
		private var boundary:MovieClip;
		private var boundaryAry:Array = new Array();
		private var boundaryCont:MovieClip;
		private var i:uint;
		private var boundId:uint;
		
		protected var model:Model = Model.instance;
		protected var control:Controller = Controller.instance;
		
		public function Boundary():void
		{
			addEventListener(Event.ENTER_FRAME, Redraw);
			
			removeBoundary()
			Draw();
		}
		
		private function Draw():void
		{
			boundaryAry = new Array();
		
			for(var b:uint = 0; b < model.IndArray.length; b++)
			{
				boundaryCont = new MovieClip();
				boundaryCont.id = b;
			
				addChildAt(boundaryCont, 0);
			
				if(b+1 == model.IndArray.length)
				{
					boundaryCont.addChild(newBoundaryLine(model.IndArray[model.IndArray.length-1], model.IndArray[0], b));
				}
				else
				{
					boundaryCont.addChild(newBoundaryLine(model.IndArray[b], model.IndArray[b+1], b));
				}
								
				boundaryAry.push(boundaryCont);
			}
		}
		
		private function newBoundaryLine(pt1:CornerIndicator, pt2:CornerIndicator, id:uint):MovieClip
		{
			boundary = new MovieClip();
			boundary.graphics.lineStyle(12, 0x00FF00, 1);
			boundary.graphics.moveTo(pt1.x, pt1.y);
			boundary.graphics.lineTo(pt1.x, pt1.y);
			boundary.graphics.lineTo(pt2.x, pt2.y);
			
			boundary.id = id;
			
			boundary.buttonMode = true;
			boundary.addEventListener(MouseEvent.MOUSE_DOWN, hitBoundary);
			
			boundary.alpha = 0;
			
			return boundary;
		}
				
		public function removeBoundary():void
		{
			for(i = 0; i < boundaryAry.length; i++)
			{
				removeChild(boundaryAry[i]);
			}
		}
		

		//=========================
		//EVENT LISTENERS
		//=========================
		private function Redraw(e:Event):void
		{
			if(model.RedrawFloor)
			{
				removeBoundary()
				Draw();
			}
		}
		
		private function hitBoundary(e:Event):void
		{
			control.addNewInd(e.currentTarget.id+1, mouseX, mouseY);
			model.Floor = model.Floor;
		}
	}
}