﻿package com.viget
{
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	public class Floor extends Sprite
	{
		protected var model:Model = Model.instance;
		
		public function Floor():void
		{	
			drawFloor();
			
			model.addEventListener(Event.CHANGE, this.update);
		}
		
		private function drawFloor():void
		{
			graphics.clear();
			graphics.beginFill(0xCCCCCC);

			for(var i:uint = 0; i < model.IndArray.length; i++)
			{
				graphics.lineTo(model.IndArray[i].x, model.IndArray[i].y);
			}

			graphics.lineTo(model.IndArray[0].x, model.IndArray[0].y);
			graphics.endFill();
		}
		
		//=========================
		//EVENT LISTENERS
		//=========================
		public function update(e:Event):void
		{
			if(model.RedrawFloor)
			{
				drawFloor();
			}
		}
	}
}