﻿package com.viget
{
	import flash.events.EventDispatcher;
	import flash.events.Event;
	import flash.display.Stage;
	import flash.display.DisplayObject;
	
	public class Model extends EventDispatcher
	{
		
		private static var _instance:Model;
		public static function get instance():Model
		{
			if(_instance == null)
				_instance = new Model();
			return _instance;
		}
		
		private var _floor:*;
		public function get Floor():*
		{
			return _floor;
		}
		
		public function set Floor(val:*):void
		{
			_floor = val;
			this.update();
		}
		
		private var _indAry:Array;
		public function get IndArray():Array
		{
			return _indAry;
		}
		
		public function set IndArray(val:Array):void
		{
			_indAry = val;
			this.update();
		}
		
		private var _boundId:uint;
		public function get BoundID():uint
		{
			return _boundId;
		}
		
		public function set BoundID(val:uint):void
		{
			_boundId = val;
			this.update();
		}
		
		private var _redrawFloor:Boolean = true;
		public function get RedrawFloor():Boolean
		{
			return _redrawFloor;
		}
		
		public function set RedrawFloor(val:Boolean):void
		{
			_redrawFloor = val;
			this.update();
		}
		
		private var _scale:Number = 10;
		public function get Scale():Number
		{
			return _scale;
		}
		
		protected function update():void
		{
			dispatchEvent(new Event(Event.CHANGE));
		}
	}
}