﻿package com.viget
{
	import flash.display.Sprite;
	
	import com.viget.*;
	
	public class Controller extends Sprite
	{
		private var i:int;
		
		protected var model:Model = Model.instance;
		
		private static var _instance:Controller;
		public static function get instance():Controller
		{
			if(_instance == null)
				_instance = new Controller();
			return _instance;
		}
		
		
		//add new indicator
		public function addNewInd(val:Number, msX:Number, msY:Number):void
		{
			var ind:CornerIndicator = new CornerIndicator();
			ind.x = model.Floor.mouseX;
			ind.y = model.Floor.mouseY;
			model.Floor.addChild(ind);
			model.IndArray.splice(val, 0, ind);
			
			model.RedrawFloor = true;
		
		}
		
		//update Id of ind
		public function updateIndIds():void
		{
			for(i = 0; i < model.IndArray.length; i++)
			{
				model.IndArray[i].IndId = i;
			}
		}
		
		public function removeInd(val:*):void
		{
			updateIndIds();
			model.IndArray.splice(val.IndId, 1);

			model.Floor.removeChild(val);
		}
	}
}